function [y_x,varyp] = MIMOcwmlpr(xx,mux,varx,beta,pcm,vary)
%function [y_x,varyp] = MIMOcwmlpr(xx,mux,varx,beta,pcm,vary)

 [I,N]=size(xx);
 O=length(beta(1,1,:));
 M=length(mux(1,:));
 y_x=zeros(O,N);
 px_cm=zeros(N,M);
 f=ones(I+1,N);
 muy=zeros(O,1);
 varyp=zeros(O,N);
 q=2*pi;
 sq=sqrt(q);
 for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
 
temp=zeros(I,I);
tempi=zeros(I,I);
for n=1:N
    for m=1:M
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(n,m)=exp(-(xx(:,n)-mux(:,m))'*tempi*(xx(:,n)-mux(:,m))*0.5)/(sqrt(det(temp))*(sq^I));
    end
end
for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
         for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
         end
       y_x(:,n)=y_x(:,n)+muy*px_cm(n,m)*pcm(m);
     end
     y_x(:,n)=y_x(:,n)/temp2;
 end
 for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
         for i=1:O
             muy(i)=(f(:,n)'*beta(:,m,i))^2;
         end
         varyp(:,n)=varyp(:,n)+(muy+vary(:,m))*px_cm(n,m)*pcm(m);
     end
     varyp(:,n)=varyp(:,n)/temp2;
 end
 varyp=varyp-y_x.^2;
 
     
 
 
 
 
 
 
 
 
 
 
 
 
 
 