function [y_x,varyp] = MIMOcwmpr(xx,mode)
% function [y_x,varyp] = MIMOcwmpr(xx,mode)
%CWM prediction for I-dimensional input to O-diemsional output
% the local model will be the same as the most recent cwmtrain local model
% mode=0: use CWM to predict, mode=1: use gradient descent to predict,
switch(mode)
    case 0
      load MIMOcwmmodel model mux varx beta pcm muy vary;
    case 1
      load sseMIMO model mux varx beta pcm vary muy;
   otherwise
    disp('mode has to be either 0 or 1');
end

% model=0,1,2 stands for Constant,Linear,Quardratic local model

switch(model)
    case 0
             
           [y_x]=MIMOcwmcpr(xx,mux,varx,muy,pcm,vary);
 
    case 1
              
            [y_x,varyp]=MIMOcwmlpr(xx,mux,varx,beta,pcm,vary);
          
    case 2
          
           
            [y_x]=MIMOcwmqpr(xx,mux,varx,beta,pcm);
          
    otherwise
        disp('model=0,1,2 stands for Constant,Linear,Quardratic local model')
end
          
