%function sseMIMOltr(xx,yy)
% function sseMIMOltr(xx,yy)
% sseMIMO Linear local model
% Minimizing Sum of Squared Error , CWM linear local model
% Specify the value of min_E
clear all;
min_E=0; 
niter=60;
load latent2 xx yy;
load MIMOcwmmodeldemo model mux varx vary beta pcm muy like;
%load sseste model mux varx muy vary beta pcm;
tx=linspace(-1,1,300);ty=yy; M=5; epsx=0;epsy=1e-30; iter=60;
O=length(yy(:,1));
[I,N]=size(xx);
M=length(mux(1,:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing vary
for i=1:O
    miny(i)=min(yy(i,:));
    maxy(i)=max(yy(i,:));
end
 for m=1:M
    vary(:,m)=(maxy-miny)';
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%load sseMIMO model mux varx muy vary beta pcm;

%load sseste model mux varx muy vary beta pcm;
%%%%%%%%%%%%%%%%%%%%%%
epsy=0;
%%
posteriors=zeros(N,M);
%betacurve=zeros(I+1,2000,M);
%%
f=ones(I+1,N);
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
%%%%%
 muy=zeros(O,1);
 no=zeros(1,O);
 e=zeros(1,O);
 muyp=zeros(O,M);
%  gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
% gradientP=zeros(1,M); gradientbeta=zeros(I+1,M,O);
% gradientZ=zeros(1,M);
%%%%% 
for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
%%%%%%%%%%%%%%%% drawing space %%%%%%
for i=1:I
    minx(i)=min(xx(i,:));
    maxx(i)=max(xx(i,:));
end
nplot=40;
if I==1
xplot=linspace(minx(1),maxx(1),nplot);
end

if I==2
    xplot1=linspace(minx(1),maxx(1),nplot);
    xplot2=linspace(minx(2),maxx(2),nplot);
    [x1,x2]=meshgrid(xplot1,xplot2);
end
%%%%%%%%%%%%%%%%
 SDx=sqrt(varx); Z=log(pcm);
phi=0.001; phi2=0.001; phi3=0.0001; % notice phi !
%%%%%%%%%%%%%%%%%%%%%%%%%%varx update change %%%%%%%%%%%%%%%
MSE=777; 
%min_E=1e-6;
epoch=1;
msecurve=[];
like=[];

tic
%while MSE>min_E %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while epoch<=niter %% choose one line to comment
MSE=0;   
%%%%%%% Calculating gradients --- sequential learning --- %%%
% feed-forward process
Seq=randperm(N); %%%% here comes the randomness ~
for n=1:N
    j=Seq(n);
  for m=1:M
           Vxi=varx(:,m).^-1; 
           t=xx(:,j)-mux(:,m);
           t=t.^2;
           px_cm(j,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end   
  de=0; 
     for m=1:M
         de=de+px_cm(j,m)*pcm(m);
     end
     
   y_x=zeros(O,1);
 for d=1:O   
     for m=1:M 
         muyp(d,m)=f(:,j)'*beta(:,m,d);
     end
    
     for m=1:M
         y_x(d)=y_x(d)+muyp(d,m)*px_cm(j,m)*pcm(m);
     end
     no(d)=y_x(d);
     y_x(d)=y_x(d)/de;
     e(d)=yy(d,j)-y_x(d);
      
       MSE=MSE+e(d)^2;
 end
    %%%%%%%%% Calculating gradients (backward process) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
gradientP=zeros(1,M); gradientbeta=zeros(I+1,M,O);
gradientZ=zeros(1,M);
for d=1:O
    for m=1:M
        for i=1:I
            g=(xx(i,j)-mux(i,m))/SDx(i,m)^2;
            gradientMx(i,m)=gradientMx(i,m)-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g*de-pcm(m)*px_cm(j,m)*g*no(d))/de^2;
         % gradientMx(i,m)=-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g*de-pcm(m)*px_cm(j,m)*g*no(d))/de^2;
        end
      %  s=xx(:,n)-mux(:,m);
        for i=1:I  
            g2=((xx(i,j)-mux(i,m))^2/SDx(i,m)^3)-1/SDx(i,m);
            gradientSDx(i,m)=gradientSDx(i,m)-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g2*de-pcm(m)*px_cm(j,m)*g2*no(d))/de^2;
            %gradientSDx(i,m)=-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g2*de-pcm(m)*px_cm(j,m)*g2*no(d))/de^2;
        end
        
        for i=1:I+1
            gradientbeta(i,m,d)=-e(d)*px_cm(j,m)*pcm(m)*f(i,j)/de;
        end
   
        gradientP(m)=gradientP(m)-e(d)*(muyp(d,m)*px_cm(j,m)*de-px_cm(j,m)*no(d))/de^2;
       %gradientP(m)=-e(d)*(muyp(d,m)*px_cm(j,m)*de-px_cm(j,m)*no(d))/de^2;
%        gradientZ(m)=gradientP(m)*(pcm(m)-pcm(m)^2);
    end
end
  gradientZ=gradientP.*(pcm-pcm.^2);
%%% updating parameters %%%
 mux=mux-phi*gradientMx;
  SDx=SDx-phi2*gradientSDx;
%     beta(:,:,O)=beta(:,:,O)-phi*gradientbeta(:,:,O);

 beta=beta-phi*gradientbeta;
    Z=Z-phi*gradientZ; 
    pcm=exp(Z)./sum(exp(Z));
     varx=SDx.^2;
end % end of n=1:N


 %  After one epoch, draw the likelihood value
for n=1:N
    for m=1:M
        for i=1:O
            muy(i)=f(:,n)'*beta(:,m,i);
        end
          Vyi=vary(:,m).^-1; 
          t2=yy(:,n)-muy; %%% very close to zero...
          t2=t2.^2;
          
          div=(sqrt(prod(vary(:,m)))*(sqo));
          if div<realmin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
              div=realmin;
          end
          py_xcm(n,m)=exp(-t2'*Vyi*0.5)/div; %%% why zero?
    end
end
     loglikeli=0;
    for n=1:N
      temp=0;
        for m=1:M
         temp=temp+px_cm(n,m)*py_xcm(n,m)*pcm(m);
        end 
        loglikeli=log(temp)+loglikeli;
    end   
         like(epoch)=loglikeli;
  %% update (estimate) vary by using EM (could still maximize likelihood function) %%
  % E-step
   for n=1:N
           temp2=0;
        for m=1:M
        temp2=temp2+py_xcm(n,m)*px_cm(n,m)*pcm(m);
        end
        for m=1:M
            posteriors(n,m)=py_xcm(n,m)*px_cm(n,m)*pcm(m)/temp2; 
        end
    end
   % M-step
   s=sum(posteriors);
for i=1:O
  for m=1:M
         temp3=0;    
        for n=1:N
         muy(i)=f(:,n)'*beta(:,m,i);
         temp3=temp3+(yy(i,n)-muy(i))*(yy(i,n)-muy(i))*posteriors(n,m);
        end
        if s(m)<realmin     %%%%%%%%%%%%%%%%%%%%%
            s(m)=realmin;
        end
      vary(i,m)=epsy+temp3/s(m); 
   end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MSE=MSE/N;
msecurve(epoch)=sqrt(MSE);
%%%% draw %%%%%%%%%%%%%%%%%%%%%%
if I==2
subplot(3,1,1);
    for m=1:M
         mu=mux(:,m); 
             temp=diag(varx(:,m));
             tempi=varx(:,m).^-1;
             p=exp(-0.5*(tempi(1)*(x1-mu(1)).^2+tempi(2)*(x2-mu(2)).^2))/(sqrt((2*pi).^2)*sqrt(det(temp)))*pcm(m); % p(x,cm)
             hold on;
             view(3);
             surf(x1,x2,p);
%             axis tight;
             hold off;
         end
    % pause(0);
      %pause
   end
if I==1
    temp=0;
    hold off;
    subplot(4,1,2);
    for m=1:M
        p=pcm(m)*exp(-0.5*(xplot-mux(m)).^2/varx(m))/(sqrt(2*pi*varx(m)));
        plot(xplot,p);
        hold on
     end
   pause(0.01);     
end % end if
hold off;
%%%%%%%%%% End of drawing %%%%%%%%%%%%%%%%%%%%%
%%% plot curve %%%%
%% %  calculate MSE
% %   calculate <y_tx>
[I Nt]=size(tx);
  px_cmt=zeros(Nt,M);
 ft=ones(I+1,Nt);
 muyt=zeros(O,1);
 varyp=zeros(O,Nt);
%  q=2*pi;
%  sq=sqrt(q);
 for i=2:(I+1)
    for n=1:Nt
        ft(i,n)=tx(i-1,n);
    end
end
 
temp=zeros(I,I);
tempi=zeros(I,I);
for n=1:Nt
    for m=1:M
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cmt(n,m)=exp(-(tx(:,n)-mux(:,m))'*tempi*(tx(:,n)-mux(:,m))*0.5)/(sqrt(det(temp))*(sq^I));
    end
end
y_x=zeros(1,Nt);
for n=1:Nt
     temp2=0;
     for m=1:M
         temp2=temp2+px_cmt(n,m)*pcm(m);
         for i=1:O
            muyt(i)=ft(:,n)'*beta(:,m,i);
         end
       y_x(:,n)=y_x(:,n)+muyt*px_cmt(n,m)*pcm(m);
     end
     y_x(:,n)=y_x(:,n)/temp2;
 end
  for n=1:Nt
     temp2=0;
     for m=1:M
         temp2=temp2+px_cmt(n,m)*pcm(m);
         for i=1:O
             muyt(i)=(ft(:,n)'*beta(:,m,i))^2;
         end
         varyp(:,n)=varyp(:,n)+(muyt+vary(:,m))*px_cmt(n,m)*pcm(m);
     end
     varyp(:,n)=varyp(:,n)/temp2;
 end
 varyp=varyp-y_x.^2;
 varyp=sqrt(abs(varyp));
 y_xv1=y_x+varyp;
 y_xv2=y_x-varyp;
   %%%%%%%% plot %%%%%%
   hold off;
  % title(epoch);
  subplot(4,1,1);
   plot(xx,yy,'o');
  hold on;
   plot(tx,y_x,'r');
   plot(tx,y_xv1,'k--');
   plot(tx,y_xv2,'k--');
     hold off;
    pause(0)
    %%% plot curve %%%%
subplot(4,1,3);
plot(msecurve,'b');
subplot(4,1,4);
plot(like,'r')
pause(0.01);
%%%%%%%%%%%%%%%%%%
  
%betacurve(:,epoch,:)=beta;
%  if toc>5
%         [MSE]
%         [loglikeli]
%         [epoch]
%      tic
%    end
  epoch=epoch+1;
end  % End of while 
%save sseMIMO model mux varx muy vary beta pcm;
clear all;