function [err]=msee(yy,y_x,mode)
% function [err]=msee(yy,y_x,mode)
% mode=0:MSE, 1:NMSE, 2:MAE, 3: DS :Directional symmetry


[O N]=size(yy);

switch(mode)
    case 0
       err=sum(sum((yy-y_x).^2))/N;
    case 1
       vary=std(yy,0,2).^2;
      err=sum(sum(sum((yy-y_x).^2))/(N*vary));
    case 2
        err=sum(sum(abs(yy-y_x)))/N;
    case 3
        err=0;
        for i=2:N
            if (yy(i)-yy(i-1))*(y_x(i)-y_x(i-1))>=0
                err=err+1;
            else
                err=err+0;
            end
        end
        err=err*100/(N-1); % (N-2) ???
  
    otherwise
        disp('mode = 0,1,2 3');
end