function [x,minf,maxf]=scale(x)
% function [x,minf,maxf]=scale(x)
% scale x to [-1 1]; minf and maxf can be used to scale it back with
% [x]=invscale(x,minf,maxf)
[I,N]=size(x); minf=zeros(1,I); maxf=zeros(1,I);

for i=1:I
    minf(i)=min(x(i,:));
    maxf(i)=max(x(i,:));
end

for n=1:N
    for i=1:I
        temp=maxf(i)-minf(i);
    x(i,n)=-1+2*((x(i,n)-minf(i))/temp);
end
end