%
% cwm.m
% (c) Neil Gershenfeld  9/1/97
% 1D Cluster-Weighted Modeling example
%
clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% x = (-10:10)'; (statble)
% y=[3 -3 4 -1 23 6 -7 8 3 -3 14 -3 26 -7 23 -3 11 4 -6 7 -28]' ;
%y = (x > 0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %x=[-9 -3 0 7]'; % x jj (mostly stable)
 %y=[23 33 12 0]';
% train n clusters |jܻ
x=[-10 -8 -4 -2 0 1 3 4 7 11 ]';
y=[1 2 3 2 3 4 5 2 3 10]';
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % x=[1 2 -5 -4 5 -2 -1 0 -7 -6 3 4 -3 6 ]';  % 14 training pairs ,x ǫDWTw still works(stable)
  % y=[-5 32 25 16 9 4 1 0 1 4 9 16 25 36 ]' ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% can't work
% x=[-40 -40 -30 -46 -40 39]';% -1 0 1 2 3 4 5 6 7]'; 
%  y=[-3 20 4 16 9 4]';% 1 0 1 4 9 16 25 36 49]' ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Y y>38.45 or < - 38.45 h y bCcluster py_given_x_cm=0
% ]ȱaJGͪs
% matlab|L@s(underflow will be represented as 0 in matlab)

%ҥHoutput ynscaling to [-38 38]. 

% numerical errors X{beϮyШIW,doesn't matter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%y=x;

%can't work

%y=2*x;
npts = length(x);               %npts=21training points

%plot(x,y,'+');
xlabel('x');
ylabel('y');
nclusters = 10;
nplot = 100;                    %nplot=100xbWneXI    
xplot = 24*(1:nplot)'/nplot - 12;%100ӦbxbW(-12,12) predicted input space
%--------------initialization--------------------------%
 % mux = 20*rand(1,nclusters) - 10; % randomMclusters mean [-10,10] %%%%%%%%%%%%%%%%%%%%%%%%% 
 a=min(x); b=max(x);
 mux=(b-a)*rand(1,nclusters)+a; % randomMclusters mean [min(x),max(x)] 

muy = ones(1,nclusters);        % ymeanl1
varx = ones(1,nclusters);        % x variance l1
vary = ones(1,nclusters);        % y variance l1
pc = 1/nclusters * ones(1,nclusters); % l P(Cm)
niterations = 40;
eps = .01; 
%-------------------------------------------------------%
for step = 1:niterations
   pplot = exp(-(kron(xplot,ones(1,nclusters)) ...    % xplot is input space
      -kron(ones(nplot,1),mux)).^2 ...
      ./ (2*kron(ones(nplot,1),varx))) ...           
      ./ sqrt(2*pi*kron(ones(nplot,1),varx)) ...
      .* kron(ones(nplot,1),pc); %HP(Cm) 

   plot(xplot,pplot,'b');                          %eXP(x_given_cluster)*P(Cm)Gfor xb(predicted input space )
                                         %Just a demonstration of the training
%% process, doesn't effect the training and predicting result.
%pause(0); 
 pause;
   px = exp(-(kron(x,ones(1,nclusters)) ...        %P(x_given_cluster)G for training data x
      - kron(ones(npts,1),mux)).^2 ...
      ./ (2*kron(ones(npts,1),varx))) ...
      ./ sqrt(2*pi*kron(ones(npts,1),varx));
   py = exp(-(kron(y,ones(1,nclusters)) ...        %P(y_given_x_cluster)G for training data y
      - kron(ones(npts,1),muy)).^2 ...            
      ./ (2*kron(ones(npts,1),vary))) ...
      ./ sqrt(2*pi*kron(ones(npts,1),vary));
   p = px .* py .* kron(ones(npts,1),pc);       
   
    pp = p ./ kron(sum(p,2),ones(1,nclusters));    % update posterior pp=P(Cm_given_y_x) 
   
   pc = sum(pp)/npts;                             % update P(Cm)
%    yfit = sum(kron(ones(npts,1),muy) .* p,2) ...  
%       ./ sum(p,2);
   mux = sum(kron(x,ones(1,nclusters)) .* pp) ... % update x mean  %%%%%%%%%./(npts*pc);
      ./ (npts*pc);
   varx = eps + sum((kron(x,ones(1,nclusters)) ...% update x variance %%%%%%%%%%%%%%%%%%%%%%%%% eps %%%%%%%%%./(npts*pc);
      - kron(ones(npts,1),mux)).^2 .* pp) ...
      ./ (npts*pc);
   muy = sum(kron(y,ones(1,nclusters)) .* pp) ... % update y mean as well as bm %%%%%%%%%./(npts*pc);
      ./ (npts*pc);
   vary = eps + sum((kron(y,ones(1,nclusters)) ...
      - kron(ones(npts,1),muy)).^2 .* pp) ...     % update y variance %%%%%%%%%./(npts*pc);%%%%%%%%%%%%%%%%%%%%%%%%% eps %%%%%%%%%
      ./ (npts*pc);
   end                                            %Both x and y are  scalers,so there's only variance(no covariance)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pplot = exp(-(kron(xplot,ones(1,nclusters)) ...   % calculating the input space xplot's p(x_given_cm) for each cluster
   - kron(ones(nplot,1),mux)).^2 ...
   ./ (2*kron(ones(nplot,1),varx))) ...
  ./ sqrt(2*pi*kron(ones(nplot,1),varx)) ...
  .* kron(ones(nplot,1),pc);

yplot = sum(kron(ones(nplot,1),muy) .* pplot,2) ... % <y_given_x> prediction  f(x,bm)=muy
   ./ sum(pplot,2);
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 
%    yplot=sum(kron(ones(npts,1),muy) .*px,2)...
%        ./sum(px,2);
   
% ystdplot = sum(kron(ones(nplot,1),(muy.^2+vary)) .* pplot,2) ...% Conditional error <Py_given _x>   p.369
%    ./ sum(pplot,2) - yplot.^2;

plot(xplot,yplot,'*r');                             %eXw in red
%plot(x,yplot,'r');                                %eXۦPtraining data inputw
hold on
%plot(xplot,yplot+ystdplot,'g--');                 %eX~t in green
%plot(xplot,yplot-ystdplot,'y--');                 %eX~t in yellow
plot(x,y,'k+');                                   %eXtraining data in black + 
%axis([-12 12 -1 1.1]);
axis([-12 12 -10 10]);
plot(xplot,.8*pplot/max(max(pplot))-1,'b') ;   %eXP(x_given_cluster)*P(Cm)Gfor xb in blue
hold off
