function y_x = cwmpredict(xx)
% function y_x = cwmpredict(xx)
%CWM prediction for I-dimensional input to O-diemsional output
% the local model will be the same as the most recent cwmtrain local model

load cwmmodel model mux varx muy beta pcm betaq;

%load ssecwm model mux varx muy vary beta pcm betaq;
%load ssecwm_temp muxs varxs betas pcms; mux=muxs;varx=varxs;pcm=pcms;beta=betas; model=1;
% model=0,1,2 stands for Constant,Linear,Quardratic local model
O=length(mux(1,1,:));
[I,N]=size(xx);
y_x=zeros(O,N);

switch(model)
    case 0
          for i=1:O
              %function y_x = cwmconstantpredict(xx,mux,varx,muy,pcm)
              y_x(i,:)=cwmconstantpredict(xx,mux(:,:,i),varx(:,:,i),muy(1,:,i),pcm(1,:,i));
          end
    case 1
          for i=1:O
              %function y_x = cwmlinearpredict(xx,mux,varx,beta,pcm)
              y_x(i,:)=cwmlinearpredict(xx,mux(:,:,i),varx(:,:,i),beta(:,:,i),pcm(1,:,i));
          end
    case 2
          for i=1:O
              %function y_x = cwmquadraticpredict(xx,mux,varx,beta,pcm)
              y_x(i,:)=cwmquadraticpredict(xx,mux(:,:,i),varx(:,:,i),betaq(:,:,i),pcm(1,:,i));
          end
    otherwise
        disp('model=0,1,2 stands for Constant,Linear,Quardratic local model')
end
          
