function cwmtrain(model,xx,yy,M,iter,epsx,epsy)
% function cwmtrain(model,xx,yy,M,iter,epsx,epsy)
% save cwmmodel model mux varx muy beta pcm betaq
%  CWM training for I-dimensional input to O-diemsional output
% model=0,1,2 stands for Constant,Linear,Quardratic local model
[I,N]=size(xx);
like=0;

O=length(yy(:,1));
mux=zeros(I,M,O);
varx=zeros(I,M,O);
pcm=zeros(1,M,O);
muy=zeros(1,M,O);
vary=zeros(1,M,O);
beta=zeros(I+1,M,O);
%betaq=zeros(I^2+I+1,M,O);
%betaq=zeros(2*I+1,M,O);
betaq=zeros((I^2+3*I+2)/2,M,O);

switch (model)
    case 0
        for i=1:O
            %function [mux,varx,muy,vary,pcm]= cwmconstant(xx,yy,M,iter,eps)
            [mux(:,:,i),varx(:,:,i),muy(1,:,i),vary(1,:,i),pcm(1,:,i)]=cwmconstant(xx,yy(i,:),M,iter,epsx,epsy);
            %pause;
        end
    case 1
        for i=1:O
            %function [mux,varx,beta,pcm,vary] = cwmlinear(xx,yy,M,iter,eps) 
%               muxp=zeros(I,M,iter); save cwmplot muxp;
%               muxs=zeros(I,M,iter); save sseplot muxs;
            [mux(:,:,i),varx(:,:,i),beta(:,:,i),pcm(1,:,i),vary(1,:,i),like]=cwmlinear(xx,yy(i,:),M,iter,epsx,epsy);
        
          %  mdncwm;
           %  min_E=1e-6;
           % [mux(:,:,i),varx(:,:,i),beta(:,:,i),pcm(1,:,i)]=ssecwm(min_E,mux(:,:,i),varx(:,:,i),beta(:,:,i),pcm(1,:,i));
            %pause;
        end
     case 2
        for i=1:O
            %function [mux,varx,beta,pcm] = cwmquadratic(xx,yy,M,iter,epsx,epsy)
           [mux(:,:,i),varx(:,:,i),betaq(:,:,i),pcm(1,:,i)]=cwmquadratic(xx,yy(i,:),M,iter,epsx,epsy);
           %pause;
        end
    otherwise
        disp('model=0,1,2 stands for Constant,Linear,Quardratic local model')
end

save cwmmodel model mux varx muy vary beta pcm betaq like

