function [y_x]=MIMOcwmcpr(xx,mux,varx,muy,pcm,vary);
% function [y_x] = MIMOcwmcpr(xx,mux,varx,muy,pcm,vary)

 [I,N]=size(xx);
O=length(muy(:,1));
 M=length(mux(1,:));
 y_x=zeros(O,N);
 px_cm=zeros(N,M);
 
 
 varyp=zeros(O,N);
 q=2*pi;
 sq=sqrt(q);
temp=zeros(I,I);
tempi=zeros(I,I);
for n=1:N
    for m=1:M
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(n,m)=exp(-(xx(:,n)-mux(:,m))'*tempi*(xx(:,n)-mux(:,m))*0.5)/(sqrt(det(temp))*(sq^I));
    end
end
for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
       y_x(:,n)=y_x(:,n)+muy(:,m)*px_cm(n,m)*pcm(m);
     end
     y_x(:,n)=y_x(:,n)/temp2;
end