function [xx,yy]=embed(t,d,tau,ahead)
% function [xx,yy]=embed(t,d,tau,ahead)
% t: original time-series data, d: embedding dimension, tau: time delay
% ahead-step ahead
% prediction


 N=length(t)-(1+(d-1)*tau+ahead)+1;
 Tarmin=(1+(d-1)*tau+ahead);
xx=zeros(d,N);
yy=zeros(1,N);
for in=Tarmin:length(t)
    
    for i=1:d
        xx(i,in-Tarmin+1)=t(in-Tarmin+1+(i-1)*tau);
    end
    yy(in-Tarmin+1)=t(in);
end
    