function [xx,yy,Z]=reconstruct(s,N,d,tau)
% function [xx,yy,Z]=reconstruct(s,N,d,tau)
% N number of recontructed vectors, N<=length(s)-(d-1)*tau-1 ; reconstructed dimention d
% tau: time delay
maxN=N+1;
Z=zeros(d,maxN);


Z=zeros(d,maxN); % reconstructed state-space vectors
xx=zeros(d,N);
yy=zeros(d,N);
 
%%% state space reconstruction %%%
for i=1:maxN
    for j=1:d
        Z(j,i)=s(i+(j-1)*tau);
    end
end
xx=Z(:,1:N);
yy=Z(:,2:N+1);




