function [sig]=rossler(N)
% function [sig]=rossler(N)

T=25000;
sig=zeros(1,T);

init=zeros(1,3);
lb=-10; up=5;
init(1)=lb+(up-lb)*rand(1,1);
init(2)=lb+(up-lb)*rand(1,1);
lb=0; up=15;
init(3)=lb+(up-lb)*rand(1,1);

[T2,Y]=ode45('nonfunc',[0:0.01:12500],init); % generate 1250001 data points
s=Y(:,1)';
k=50;
count=k;
for i=1:floor(length(s)/k)
    sig(i)=s(count);
    count=count+k;
end
% there are 25000 points in sig

sig=sig(5001:T);  a=1; b=20000-N;
t0 = floor(a + (b-a) * rand(1,1));
sig=sig(t0:t0+N-1);
