function [x,minf,maxf]=scale2(x,a,b)
% function [x,minf,maxf]=scale2(x,a,b)
% scale x to [a b]; minf and maxf can be used to scale it back with
% [x]=invscale(x,minf,maxf)
[I,N]=size(x); minf=zeros(1,I); maxf=zeros(1,I);

for i=1:I
    minf(i)=min(x(i,:));
    maxf(i)=max(x(i,:));
end

for n=1:N
    for i=1:I
        temp=maxf(i)-minf(i);
    x(i,n)=a+(b-a)*((x(i,n)-minf(i))/temp);
end
end