% sseMIMO Constant local model
% Minimizing Sum of Squared Error , CWM linear local model
% Specify the value of min_E
min_E=0; 
niter=2000;

load MIMOcwmmodel model mux varx vary beta pcm muy like;

%load sseste model mux varx muy vary beta pcm;

O=length(yy(:,1));
[I,N]=size(xx);
M=length(mux(1,:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Initializing vary
for i=1:O
    miny(i)=min(yy(i,:));
    maxy(i)=max(yy(i,:));
end
 for m=1:M
    vary(:,m)=(maxy-miny)';
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%load sseMIMO model mux varx muy vary beta pcm;

%load sseste model mux varx muy vary beta pcm;
%%%%%%%%%%%%%%%%%%%%%%
epsy=1e-20;
%%
posteriors=zeros(N,M);
%betacurve=zeros(I+1,2000,M);
%%
q=2*pi;
sq=sqrt(q);
sqi=sq^I;
sqo=sq^O;
px_cm=zeros(N,M);
py_xcm=zeros(N,M);
%%%%%
 
 no=zeros(1,O);
 e=zeros(1,O);
 muyp=zeros(O,M);
%  gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
% gradientP=zeros(1,M); gradientbeta=zeros(I+1,M,O);
% gradientZ=zeros(1,M);

 SDx=sqrt(varx); Z=log(pcm);
phi=0.00001; phi2=0.001; phi3=0.0001; % notice phi !
%%%%%%%%%%%%%%%%%%%%%%%%%%varx update change %%%%%%%%%%%%%%%
MSE=777; 
%min_E=1e-6;
epoch=1;
msecurve=[];
like=[];

tic
while MSE>min_E %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%while epoch<=niter %% choose one line to comment
MSE=0;   
%%%%%%% Calculating gradients --- sequential learning --- %%%
% feed-forward process
Seq=randperm(N); %%%% here comes the randomness ~
for n=1:N
    j=Seq(n);
  for m=1:M
           Vxi=varx(:,m).^-1; 
           t=xx(:,j)-mux(:,m);
           t=t.^2;
           px_cm(j,m)=exp(-t'*Vxi*0.5)/(sqrt(prod(varx(:,m)))*(sqi));
    end   
  de=0; 
     for m=1:M
         de=de+px_cm(j,m)*pcm(m);
     end
     
   y_x=zeros(O,1);
 for d=1:O   
     
    
     for m=1:M
         y_x(d)=y_x(d)+muy(d,m)*px_cm(j,m)*pcm(m);
     end
     no(d)=y_x(d);
     y_x(d)=y_x(d)/de;
     e(d)=yy(d,j)-y_x(d);
      
       MSE=MSE+e(d)^2;
 end
    %%%%%%%%% Calculating gradients (backward process) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 gradientMx=zeros(I,M);  gradientSDx=zeros(I,M); 
gradientP=zeros(1,M); gradientmuy=zeros(O,M);
gradientZ=zeros(1,M);
for d=1:O
    for m=1:M
        for i=1:I
            g=(xx(i,j)-mux(i,m))/SDx(i,m)^2;
            gradientMx(i,m)=gradientMx(i,m)-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g*de-pcm(m)*px_cm(j,m)*g*no(d))/de^2;
         % gradientMx(i,m)=-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g*de-pcm(m)*px_cm(j,m)*g*no(d))/de^2;
        end
      %  s=xx(:,n)-mux(:,m);
        for i=1:I  
            g2=((xx(i,j)-mux(i,m))^2/SDx(i,m)^3)-1/SDx(i,m);
            gradientSDx(i,m)=gradientSDx(i,m)-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g2*de-pcm(m)*px_cm(j,m)*g2*no(d))/de^2;
            %gradientSDx(i,m)=-e(d)*(muyp(d,m)*pcm(m)*px_cm(j,m)*g2*de-pcm(m)*px_cm(j,m)*g2*no(d))/de^2;
        end
        
        
            gradientmuy(d,m)=-e(d)*px_cm(j,m)*pcm(m)/de;
            
   
        gradientP(m)=gradientP(m)-e(d)*(muyp(d,m)*px_cm(j,m)*de-px_cm(j,m)*no(d))/de^2;
       %gradientP(m)=-e(d)*(muyp(d,m)*px_cm(j,m)*de-px_cm(j,m)*no(d))/de^2;
%        gradientZ(m)=gradientP(m)*(pcm(m)-pcm(m)^2);
    end
end
  gradientZ=gradientP.*(pcm-pcm.^2);
%%% updating parameters %%%
 mux=mux-phi*gradientMx;
   SDx=SDx-phi2*gradientSDx;
    % muy=muy-phi*gradientmuy;
     Z=Z-phi*gradientZ; 
     pcm=exp(Z)./sum(exp(Z));
     varx=SDx.^2;
end % end of n=1:N


 %  After one epoch, draw the likelihood value
for n=1:N
    for m=1:M
%         for i=1:O
%             muy(i)=f(:,n)'*beta(:,m,i);
%         end
          Vyi=vary(:,m).^-1; 
          t2=yy(:,n)-muy(:,m); %%% very close to zero...
          t2=t2.^2;
          
          div=(sqrt(prod(vary(:,m)))*(sqo));
          if div<realmin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
              div=realmin;
          end
          py_xcm(n,m)=exp(-t2'*Vyi*0.5)/div; %%% why zero?
    end
end
     loglikeli=0;
    for n=1:N
      temp=0;
        for m=1:M
         temp=temp+px_cm(n,m)*py_xcm(n,m)*pcm(m);
        end 
        loglikeli=log(temp)+loglikeli;
    end   
         like(epoch)=loglikeli;
  %% update (estimate) vary by using EM (could still maximize likelihood function) %%
  % E-step
   for n=1:N
           temp2=0;
        for m=1:M
        temp2=temp2+py_xcm(n,m)*px_cm(n,m)*pcm(m);
        end
        for m=1:M
            posteriors(n,m)=py_xcm(n,m)*px_cm(n,m)*pcm(m)/temp2; 
        end
    end
   % M-step
   s=sum(posteriors);
for i=1:O
  for m=1:M
         temp3=0;    
        for n=1:N
        
         temp3=temp3+(yy(i,n)-muy(i,m))*(yy(i,n)-muy(i,m))*posteriors(n,m);
        end
        if s(m)<realmin     %%%%%%%%%%%%%%%%%%%%%
            s(m)=realmin;
        end
      vary(i,m)=epsy+temp3/s(m); 
   end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MSE=MSE/N;
msecurve(epoch)=sqrt(MSE);
%%% plot curve %%%%
subplot(2,1,1);
plot(msecurve,'b');
subplot(2,1,2);
plot(like,'r')
pause(0);
%%%%%%%%%%%%%%%%%%
%betacurve(:,epoch,:)=beta;
 if toc>5
        [MSE]
        [loglikeli]
        [epoch]
     tic
   end
  epoch=epoch+1;
end  % End of while 
save sseMIMO model mux varx muy vary beta pcm;