function y_x = cwmquadraticpredict(xx,mux,varx,betaq,pcm)
%function y_x = cwmquadraticpredict(xx,mux,varx,beta,pcm)

 [I,N]=size(xx);
 M=length(mux(1,:));
 y_x=zeros(1,N);
 px_cm=zeros(N,M);
  muyp=zeros(N,M);
 %f=ones(I^2+I+1,N);
 %f=ones(2*I+1,N);
 f=ones((I^2+3*I+2)/2,N);
 q=2*pi;
 for i=2:(I+1)
    for n=1:N
        f(i,n)=xx(i-1,n);
    end
end
% k=I+2;
% for i=1:I
%     for j=1:I
%        for n=1:N
%            f(k,n)=xx(i,n)*xx(j,n);
%        end
%              k=k+1;
%        end
%    end
 
k=I+2;
for i=1:I
    for n=1:N
        f(k,n)=xx(i,n)*xx(i,n);
    end
    k=k+1;
end
k=2*I+2;
for i=1:I
    for j=i+1:I
        for n=1:N
            f(k,n)=xx(i,n)*xx(j,n);
        end
        k=k+1;
    end
end
temp=zeros(I,I);
tempi=zeros(I,I);
for n=1:N
    x=xx(:,n);
    for m=1:M
         mu=mux(:,m); 
         temp=diag(varx(:,m));
         tempi=diag(varx(:,m).^-1);
         px_cm(n,m)=exp(-(x-mu)'*tempi*(x-mu)*0.5)/(sqrt(det(temp))*(sqrt(q)^I));
    end
end
for m=1:M 
  for n=1:N
          muyp(n,m)=f(:,n)'*betaq(:,m);
  end
end


 for n=1:N
     temp2=0;
     for m=1:M
         temp2=temp2+px_cm(n,m)*pcm(m);
     end
     for m=1:M
         y_x(n)=y_x(n)+muyp(n,m)*px_cm(n,m)*pcm(m);
     end
     y_x(n)=y_x(n)/temp2;
 end

% print 2-d figure:
% if I==2
% xlabel('x1');
% ylabel('x2');
% zlabel('y');
% %plot3(xx(1,:),xx(2,:),yy,'bo','MarkerSize',16); % draw the training data points
% 
% plot3(xx(1,:),xx(2,:),y_x,'r+','MarkerSize',16);
% hold on;
% %plot3(x(1,1),x(2,1),predy,'k*','MarkerSize',16);
% %hold on;
% grid on;
% hold off;
% end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % print 1-d figure:
% if I==1
% xlabel('x');
% ylabel('y');
% 
% 
% plot(xx,y_x,'r+');
% %hold on;
% %plot(x,predy,'k*');
% hold off;
% end